-[ program "fixtable.c" ]

-[ headers, begin ]
!stdio !stdlib !string !ctype
parsedoc style repstr genlines
part decl field gencells code 
	serialize
-[end]

int main() {
	doc_t *D;
	sheet_t *S;
	grid_t *G;
	declist_t *decls;
	strpairlist_t *V;
	storage_t *storage;

	V= strpairlist_new();

	D= parse_doc(stdin);
	if (sheetlist_isempty(D->sheets))
		exit(fprintf(stderr,"no sheets in document!\n"));
	S= sheetlist_destroy(D->sheets);
	G= apply_styles(S);
	if (sheetlist_isempty(D->sheets))
		exit(fprintf(stderr,"no declaration sheet in document\n"));

	decls= parse_declarations(
		apply_styles(sheetlist_destroy(D->sheets)));
	storage= compute_fields(G, decls,V);

	gen_lines(G, V);
	partition_bgfills(G,V);
	gen_cells(G,storage,V);

	add_simple_variables(S,G,V);

	output_serialization_code(storage,V);

/*	strpairlist_dump(V);*/
	print_code(output_file_name, V);
	
	return 0;
}

-[private] void add_simple_variables
	(sheet_t *S,grid_t *G,strpairlist_t *V)
{
	char *name;
	int i;
	char buf[200];
	strpairlist_append(V, 
		strpair_new(strdup("$CLASS"), strdup(S->name)));
	sprintf(buf,"%d",G->ncols);
	strpairlist_append(V, 
		strpair_new(strdup("$NCOLS"), strdup(buf)));
	sprintf(buf,"%d",G->nrows);
	strpairlist_append(V, 
		strpair_new(strdup("$NROWS"), strdup(buf)));
	name= S->name;
	for(i=0;name[i];i++)
		name[i]= tolower(name[i]);
	strpairlist_append(V, 
		strpair_new(strdup("$FILENAME"), name));
	-[private] char* output_file_name;
	output_file_name= name;
}


