-[ c library "repstr.c", header "repstr.h" ]


-[public] char *replace_string_f(char *data, char *from, char *to)
{
	char *B;
	B= replace_string(data,from,to);
	free(data);
	return B;
}

-[public] char *replace_string(char *data, char *from, char *to)
{
	char *B;
	B= malloc(do_replace_string(data, from, to, 0));
	do_replace_string(data, from, to, B);
	return B;
}

-[private] int do_replace_string
	(char *data,char *from,char *to,char *buffer)
{
	int L;
	char *x;
	int Lto;
	int Lfrom;

	L= 0;
	Lto= strlen(to);
	Lfrom= strlen(from);

	while((x=strstr(data,from))) {
		if (x!=data) {
			if (buffer) 
				memcpy(buffer+L, data, x-data);
			L+= x-data;
		}
		if (buffer)
			memcpy(buffer+L, to, Lto);
		L+= Lto;
		data= x+Lfrom;
	}

	if (data[0]) {
		Lto= strlen(data);
		if (buffer)
			memcpy(buffer+L, data, Lto);
		L+= Lto;
	}

	if (buffer)
		buffer[L]= 0;
	L++;
	return L;
}

-[public] typedef struct {
	char *a,*b;
} strpair_t;

-[strpairlist_t : public list of strpair_t* ]

-[public] char *do_replacements(char *src, strpairlist_t *reps)
{
	char *x;
	x= src;
	-[ list>for R ∈ *reps, begin ]
		if (x==src)
			x= replace_string(x,R->a,R->b);
		else
			x= replace_string_f(x,R->a,R->b);
	-[end]
	return x;
}


-[ headers, begin ]
	!stdlib !string !stdio
-[end]

-[public] strpair_t *strpair_new(char *a,char *b)
{
	strpair_t *P;
	-[allocate object P]
	P->a=a;
	P->b= b;
	return P;
}


-[public] void strpairlist_dump(strpairlist_t *L)
{
	-[list>for P ∈ *L, begin]
		printf("A=<%s>\n",P->a);
		printf("B=<%s>\n",P->b);
	-[end]
}
